package de.tudarmstadt.informatik.hostage.model;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;

import de.tudarmstadt.informatik.hostage.ui2.activity.MainActivity;

/**
 * @author Alexander Brakowski
 * @created 14.01.14 18:04
 */
public class Profile {
	public String text;
	public String label;
	public int id;
	public boolean activated;
	public Bitmap icon;
	public String iconPath;

	public boolean isBackVisible = false;
	public boolean editable = false;

	public Profile(int id, String label, String text, Bitmap icon, boolean editable){
		this.id = id;
		this.label = text;
		this.text = label;
		this.activated = false;
		this.icon = icon;
		this.editable = editable;
	}

	public Profile(int id, String label, String text, int icon, boolean editable){
		this(id, text, label, BitmapFactory.decodeResource(MainActivity.context.getResources(), icon), editable);
	}

	public Profile(int id, String label, String text, String iconPath, boolean editable){
		this.id = id;
		this.label = label;
		this.text = text;
		this.activated = false;
		this.iconPath = iconPath;
		this.editable = editable;
	}

	public void setIcon(Bitmap bitmap){
		this.icon = bitmap;
	}

	public void setIcon(int icon){
		this.icon = BitmapFactory.decodeResource(MainActivity.context.getResources(), icon);
	}

	public Bitmap getIconBitmap(){
		if(this.icon != null) return icon;

		if(this.iconPath != null){
			BitmapFactory.Options options = new BitmapFactory.Options();
			options.inPreferredConfig = Bitmap.Config.ARGB_8888;
			Bitmap bitmap = BitmapFactory.decodeFile(this.iconPath, options);

			return bitmap;
		}

		return null;
	}

	public Drawable getIconDrawable(){
		return new BitmapDrawable(getIconBitmap());
	}

	public boolean isEditable(){
		return this.editable;
	}

	public Profile cloneProfile(){
		return new Profile(id, label, text, icon, editable);
	}
}