package de.tudarmstadt.informatik.hostage.ui2.adapter;

import android.content.Context;
import android.os.Build;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.ViewSwitcher;

import java.util.List;

import de.tudarmstadt.informatik.hostage.R;
import de.tudarmstadt.informatik.hostage.ui2.activity.MainActivity;
import de.tudarmstadt.informatik.hostage.ui2.model.ServicesListItem;

/**
 * Created by Daniel Lazar on 06.02.14.
 */
public class ServicesListAdapter extends ArrayAdapter<ServicesListItem> {
		private class ViewHolder {
			public TextView protocolName;
			public TextView recordedAttacks;
			public Switch activated;
			public View circle;
		}

	private final Context context;
	private final List<ServicesListItem> values;
	int sdk = Build.VERSION.SDK_INT;

	ViewHolder holder = null;
	private ServicesListItem item;

	public ServicesListAdapter(Context context, List<ServicesListItem> objects){
		super(context, R.layout.services_list_item, objects);

		this.context = context;
		this.values = objects;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		LayoutInflater inflater = (LayoutInflater) context
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);

		View rowView = convertView;

		item = values.get(position);

		if(rowView == null){
			rowView = inflater.inflate(R.layout.services_list_item, parent, false);

			holder = new ViewHolder();
			holder.protocolName = (TextView) rowView.findViewById(R.id.services_item_name);
			holder.recordedAttacks = (TextView) rowView.findViewById(R.id.services_item_rec_attacks);
			holder.activated = (Switch) rowView.findViewById(R.id.services_item_switch);
			holder.circle = (View) rowView.findViewById(R.id.services_circle);
			this.notifyDataSetChanged();
			rowView.setTag(holder);
		} else {
			holder = (ViewHolder) rowView.getTag();
		}

		holder.protocolName.setText(item.protocol);

		return rowView;
	}

	@Override
	public void notifyDataSetChanged(){
		if(MainActivity.getInstance().getHoneyService().isRunning(item.protocol)){
			holder.activated.setChecked(true);
			if(sdk < Build.VERSION_CODES.JELLY_BEAN){
				holder.circle.setBackgroundDrawable(MainActivity.getInstance().getResources().getDrawable(R.drawable.services_circle_green));
			}
			else {
				holder.circle.setBackground(MainActivity.getInstance().getResources().getDrawable(R.drawable.services_circle_green));
			}
		}
		else {
			holder.activated.setChecked(false);
			if(sdk < Build.VERSION_CODES.JELLY_BEAN){
				holder.circle.setBackgroundDrawable(MainActivity.getInstance().getResources().getDrawable(R.drawable.services_circle));
			}
			else {
				holder.circle.setBackground(MainActivity.getInstance().getResources().getDrawable(R.drawable.services_circle));
			}
		}
	}

}
